IF	!DEF(UTILITY_INC)
UTILITY_INC	SET	1

; --
; -- Externally declared symbols
; --

GLOBAL	mem_Set
GLOBAL	mem_Copy
GLOBAL	mem_CopySlow
GLOBAL	mem_CopyMono
GLOBAL	mem_SetVRAM 
GLOBAL	mem_CopyVRAM
GLOBAL	fade_Init
GLOBAL	fade_Decrease
GLOBAL	fade_Increase
GLOBAL	fade_Process
GLOBAL	lcd_DisplayOff
GLOBAL	lcd_WaitVRAM
GLOBAL	gbi_Show
GLOBAL	gbi_VBlank
GLOBAL	z80_SetBank
GLOBAL	z80_LongCall
GLOBAL	z80_LongJp
GLOBAL	pad_Read
GLOBAL  StartLCD
GLOBAL  StopLCD
GLOBAL	_PadData
GLOBAL	_PadDataEdge


; GG = b00  - I am a gameboy or super gameboy
; GG = b11  - I am a gameboy pocket        
; GG = b01  - I am a color gameboy
GLOBAL	gbtype

; --
; -- A few macros to do easy far branching
; --

lcall:	MACRO
	ld	a,BANK(\1)
	ld	hl,\1
	call	z80_LongCall
	ENDM

ljp:	MACRO
	ld	a,BANK(\1)
	ld	hl,\1
	jp	z80_LongJp
	ENDM

; --
; -- Other useful macros
; --

pusha:	MACRO
	push	af
	push	bc
	push	de
	push	hl
	ENDM

popa:	MACRO
	pop	hl
	pop	de
	pop	bc
	pop	af
	ENDM


; --
; -- STRUCT sFade
; --

RSRESET
fd_ubIntensity	RB	1
fd_ubPalette	RB	1
fd_ubFade0	RB	1
fd_ubFade1	RB	1
fd_ubFade2	RB	1
fd_ubFade3	RB	1
fd_SIZEOF	RB	0

ENDC	;UTILITY_INC
