INCLUDE "gbhw.inc"
INCLUDE "utility.inc"
INCLUDE "irq.inc"
INCLUDE "ibmpc1.inc"
INCLUDE "user.inc"
INCLUDE "thread.inc"
INCLUDE "user.inc"

SECTION "SupportCode",CODE

EXPORT update0
EXPORT update1
EXPORT update2
EXPORT update3
EXPORT update4
EXPORT cpudump
EXPORT tohexb
EXPORT tohex
EXPORT scratch0

;hl = tick
;bc = thread
;de = screen offset

cpudump:
	push 	af
	push	bc
	push	de
	push 	hl

	push	de

	ld	a,[hl+]
	ld	d,a
	ld	a,[hl+]
	ld	e,a


	; hl is free

	ld	bc,scratch0
	call	tohex
	; recover de
	pop	hl
	ld      de,$9800+(SCRN_VY_B*0)
	add	hl,de
	ld	d,h
	ld	e,l
        ld      bc,4
        ld      hl,scratch0
        call    mem_Copy

	;
	; display PC
	;
	;
	; recover variables
	;
	pop 	hl
	pop	de
	pop	bc
	push	bc
	push	de
	push 	hl
	push	de
	;
	ld 	hl,contextblocksize-2
	add	hl,bc		
	; point to this threads context block
	ld	a,[hl+]
	ld	e,a
	ld	a,[hl+]
	ld	d,a
	ld	bc,scratch0
	call	tohex
	; reover de
	pop	hl
	ld      de,$9800+7+(SCRN_VY_B*0)
	add	hl,de
	ld	d,h
	ld	e,l
        ld      bc,4
        ld      hl,scratch0
        call    mem_Copy


	;
	; display SP
	;
	;
	; recover variables
	;
	pop 	hl
	pop	de
	pop	bc
	push	bc
	push	de
	push 	hl
	push	de
	;
	ld 	hl,context_sp
	add	hl,bc		
	; point to this threads context block
	ld	a,[hl+]
	ld	d,a
	ld	a,[hl+]
	ld	e,a
	ld	bc,scratch0
	call	tohex
	; reover de
	pop	hl
	ld      de,$9800+14+(SCRN_VY_B*0)
	add	hl,de
	ld	d,h
	ld	e,l
        ld      bc,4
        ld      hl,scratch0
        call    mem_Copy



	;
	; display AF
	;
	;
	; recover variables
	;
	pop 	hl
	pop	de
	pop	bc
	push	bc
	push	de
	push 	hl
	push	de
	;
	ld 	hl,contextblocksize-4
	add	hl,bc		
	; point to this threads context block
	ld	a,[hl+]
	ld	e,a
	ld	a,[hl+]
	ld	d,a
	ld	bc,scratch0
	call	tohex
	; reover de
	pop	hl
	ld      de,$9800+7+(SCRN_VY_B*1)
	add	hl,de
	ld	d,h
	ld	e,l
        ld      bc,4
        ld      hl,scratch0
        call    mem_Copy


	;
	; display BC
	;
	;
	; recover variables
	;
	pop 	hl
	pop	de
	pop	bc
	push	bc
	push	de
	push 	hl
	push	de
	;
	ld 	hl,contextblocksize-6
	add	hl,bc		
	; point to this threads context block
	ld	a,[hl+]
	ld	e,a
	ld	a,[hl+]
	ld	d,a
	ld	bc,scratch0
	call	tohex
	; reover de
	pop	hl
	ld      de,$9800+14+(SCRN_VY_B*1)
	add	hl,de
	ld	d,h
	ld	e,l
        ld      bc,4
        ld      hl,scratch0
        call    mem_Copy


	;
	; display DE
	;
	;
	; recover variables
	;
	pop 	hl
	pop	de
	pop	bc
	push	bc
	push	de
	push 	hl
	push	de
	;
	ld 	hl,contextblocksize-8
	add	hl,bc		
	; point to this threads context block
	ld	a,[hl+]
	ld	e,a
	ld	a,[hl+]
	ld	d,a
	ld	bc,scratch0
	call	tohex
	; reover de
	pop	hl
	ld      de,$9800+7+(SCRN_VY_B*2)
	add	hl,de
	ld	d,h
	ld	e,l
        ld      bc,4
        ld      hl,scratch0
        call    mem_Copy

	;
	; display HL
	;
	;
	; recover variables
	;
	pop 	hl
	pop	de
	pop	bc
	push	bc
	push	de
	push 	hl
	push	de
	;
	ld 	hl,contextblocksize-10
	add	hl,bc		
	; point to this threads context block
	ld	a,[hl+]
	ld	e,a
	ld	a,[hl+]
	ld	d,a
	ld	bc,scratch0
	call	tohex
	; reover de
	pop	hl
	ld      de,$9800+14+(SCRN_VY_B*2)
	add	hl,de
	ld	d,h
	ld	e,l
        ld      bc,4
        ld      hl,scratch0
        call    mem_Copy


	pop 	hl
	pop	de
	pop	bc
	pop 	af

	ret

;
; This prints out the register dump for process 1
;


update0:
	pusha

        ld      hl,tick0
        ld      bc,thread0
        ld      de,+0+(SCRN_VY_B*1)
        call cpudump

	popa
	ret

;
; This prints out the register dump for process 1
;


update1:
	pusha

        ld      hl,tick1
        ld      bc,thread1
        ld      de,+0+(SCRN_VY_B*4)
        call cpudump

	popa
	ret

update2:
	pusha

        ld      hl,tick2
        ld      bc,thread2
        ld      de,+0+(SCRN_VY_B*7)
        call cpudump

	popa
	ret

update3:
	pusha

        ld      hl,tick3
        ld      bc,thread3
        ld      de,+0+(SCRN_VY_B*10)
        call cpudump

	popa
	ret

update4:
	pusha

        ld      hl,tick4
        ld      bc,thread4
        ld      de,+0+(SCRN_VY_B*13)
        call cpudump

	popa
	ret

HexChars:
        DB      "0123456789ABCDEF"


; *** turn de into a hex string (memory at hl)
; DE - integer
; BC - address of final string
tohex::

	pusha	
	push 	bc
	xor 	a
	ld 	b,a
        ld     	a,d		; get first byte of DE
	swap 	a
	and	$f		; get first 4 bits
	ld	c,a
	ld	hl,HexChars	; point to the start of our address
	add	hl,bc		; create our address
	ld	a,[hl]		; get our character
	pop	bc
	ld	[bc],a
	inc 	bc

	push 	bc
	xor 	a
	ld 	b,a
        ld      a,d		; get first byte of DE
	and	$f		; get first 4 bits
	ld	c,a
	ld	hl,HexChars	; point to the start of our address
	add	hl,bc		; create our address
	ld	a,[hl]		; get our character
	pop	bc
	ld	[bc],a
	inc 	bc

	push 	bc		; save our destination
	xor 	a		; a = 0;
	ld 	b,a		; b = a;
	ld	a,e		; a = e;
	swap	a
	and	$f		; get first 4 bits
	ld	c,a
	ld	hl,HexChars	; point to the start of our address
	add	hl,bc		; create our address
	ld	a,[hl]		; get our character
	pop	bc
	ld	[bc],a
	inc	bc

	push 	bc
	xor 	a
	ld 	b,a
        ld     	a,e		; get first byte of DE
	and	$f		; get first 4 bits
	ld	c,a
	ld	hl,HexChars	; point to the start of our address
	add	hl,bc		; create our address
	ld	a,[hl]		; get our character
	pop	bc
	ld	[bc],a

	; do the fourth chacacter

	popa

        ret     nc              ; Exit.

; *** turn d into a hex string (memory at hl)
; DE - integer
; BC - address of final string
tohexb::

	pusha	
	push 	bc
	xor 	a
	ld 	b,a
        ld     	a,d		; get first byte of DE
	swap 	a
	and	$f		; get first 4 bits
	ld	c,a
	ld	hl,HexChars	; point to the start of our address
	add	hl,bc		; create our address
	ld	a,[hl]		; get our character
	pop	bc
	ld	[bc],a
	inc 	bc

	push 	bc
	xor 	a
	ld 	b,a
        ld      a,d		; get first byte of DE
	and	$f		; get first 4 bits
	ld	c,a
	ld	hl,HexChars	; point to the start of our address
	add	hl,bc		; create our address
	ld	a,[hl]		; get our character
	pop	bc
	ld	[bc],a
	inc 	bc

	popa

        ret     nc              ; Exit.



SECTION        "SupportVars",BSS
        
EXPORT  scratch0

scratch0:        DS      4


;* End of File *
